=== debian/changelog ===
vtk (5.6.1-7) unstable; urgency=low

  * Drop obsolete paths from CMakeCache.txt.debian.
    Thanks to Julien Cristau (Closes: #643814)

 -- Dominique Belhachemi <domibel@debian.org>  Fri, 30 Sep 2011 20:48:45 -0400

vtk (5.6.1-6.1) unstable; urgency=low

  [ Michael Schutte ]
  * Non-maintainer upload.
  * Remove absolute paths to required libraries from
    /usr/lib/vtk-5.6/VTKLibraryDepends.cmake after building, closes:
    #506992.  Due to the multiarch transition, the original behavior
    frequently causes reverse build-deps to FTBFS.  This change should
    probably be reverted once all required libraries are multiarched.
  
  [ Steve M. Robbins ]
  * Override lintian diagnostic about embedded libraries ftgl and sqlite.
  * IO/vtkFFMPEGWriter.cxx: Applied fix from #638246 to build with libav
    0.7.

 -- Steve M. Robbins <smr@debian.org>  Thu, 01 Sep 2011 23:35:32 -0500

vtk (5.6.1-6) unstable; urgency=low

  * VolumeRendering/vtkOpenGLGPUVolumeRayCastMapper.cxx:
  *   - Make mapper more verbose if GPU is not supported.
  *   - Don't deactivate the mapper if the 'OpenGL renderer string'
  *     contains 'Mesa' (e.g. Intel GPU's) (Closes: #600424)

 -- Dominique Belhachemi <domibel@debian.org>  Thu, 02 Jun 2011 23:21:18 -0400

vtk (5.6.1-5) unstable; urgency=low

  *  Include <stddef.h> to ensure ptrdiff_t is defined. (Closes: #624878)

 -- Dominique Belhachemi <domibel@debian.org>  Sat, 07 May 2011 12:01:54 -0400

vtk (5.6.1-4) unstable; urgency=low

  * vtkEncodeString is in /usr/lib/vtk-5.6 (Closes: #618519)
  * replace doxygen and texlive build dependencies with doxygen-latex
   (Closes: #616284)
  * Re-apply commit 4e1dd55 which had not been merged into 5.6.0.
    Added Break and Replace control fields (Closes: #601992, #601994)

 -- Dominique Belhachemi <domibel@debian.org>  Tue, 15 Mar 2011 20:44:14 -0400

vtk (5.6.1-3) unstable; urgency=low

  [ Dominique Belhachemi ]
  * debian/control: Added versioned dependency for python-dev (Closes: #604467)
  * debian/control: vtk-examples suggests libqt4-dev (Closes: #612952)
  * debian/rules: use find/xargs combination to delete *.md5 files,
                  avoids that rm is failing because of a long argument list
  * debian/rules: Make cmake output verbose if DH_VERBOSE is set

  [ Denis Barbier ]
  * Fix FTBFS on kfreebsd.  (Closes: #614134)

 -- Dominique Belhachemi <domibel@debian.org>  Mon, 21 Feb 2011 17:17:49 -0500

vtk (5.6.1-2) unstable; urgency=low

  * Upload to unstable (Closes: #604388, #613907, #613908, #6139011)
  * Link against Debian's system netcdf instead of vtknetcdf
  * removed libvtkNetCDF_cxx.so* (Closes: #602065)
  * Added workaround for FFMPEG build error

 -- Dominique Belhachemi <domibel@debian.org>  Thu, 17 Feb 2011 18:26:48 -0500

vtk (5.6.1-1) experimental; urgency=low

  * new upstream patch release
  * Bump Standards-Version to 3.9.1(no changes needed)
  * added libvtkNetCDF_cxx.so.*

 -- Dominique Belhachemi <domibel@debian.org>  Sun, 24 Oct 2010 13:23:50 -0400

vtk (5.6.0-2) experimental; urgency=low

  * Package tcl-vtk depends now on libvtk5.6 instead of libvtk5-dev
  * some link target changed to reduce unnecessary dependencies
  * Package is compliant to Debian policy version 3.9.0(no changes needed)

 -- Dominique Belhachemi <domibel@debian.org>  Thu, 15 Jul 2010 15:53:18 -0400

vtk (5.6.0-1) experimental; urgency=low

  * Switch to dpkg-source 3.0 (quilt) format
  * renamed package according to the Debian Tcl/Tk policy
    vtk-tcl -> tcl-vtk
  * bump library version number in runtime packages:
    libvtk5.4-qt4 -> libvtk5.6-qt4
    libvtk5.4     -> libvtk5.6
  * removed packages:
    libvtk5.4-qt3 and libvtk5-qt3-dev
  * Try not to link against unnecessary libraries

 -- Dominique Belhachemi <domibel@debian.org>  Wed, 16 Jun 2010 00:09:11 -0400

vtk (5.4.2-8) unstable; urgency=low

  * debian/control: Added Break and Replace control fields (Closes: #601992, #601994)

 -- Dominique Belhachemi <domibel@debian.org>  Sat, 06 Nov 2010 11:33:04 -0400

vtk (5.4.2-7) unstable; urgency=low

  [ Denis Barbier ]
  * copy Wrapping/Python/vtk/gtk/GtkGLExtVTKRenderWindow{,Interactor}.py
    files
  * allow building against boost 1.42 and up (Closes: #582455)
  * drop CMake/FindJNI.cmake and build-depends cmake >= 2.8.1-3 instead
  * let python-vtk build with python 2.5 or 2.6.  Report and patch by
    Fabrice Coutadeur (Closes: #582565)

 -- A. Maitland Bottoms <bottoms@debian.org>  Tue, 25 May 2010 06:54:16 -0400

vtk (5.4.2-6) unstable; urgency=low

  * remove explicit references to python2.5 (Closes: #571519, #571491)
  * make libvtk5-dev explicitly depend upon tcl8.5-dev and tk8.5-dev
    (Closes: #572189)

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 14 Apr 2010 14:40:49 -0400

vtk (5.4.2-5) unstable; urgency=low

  [ Dominique Belhachemi ]
  * Move library file libQVTKWidgetPlugin.so from
    libvtk5.4-{qt3,qt4} to libvtk5-{qt3,qt4}-dev . (Closes: #567379, #567380)

  [ Denis Barbier ]
  * CMake/FindJNI.cmake: add support for SH.
    Report and patch by Nobuhiro Iwamatsu. Closes: #568964

 -- Dominique Belhachemi <domibel@cs.tu-berlin.de>  Mon, 15 Feb 2010 18:27:01 -0500

vtk (5.4.2-4) unstable; urgency=low

  * Upload to unstable

 -- A. Maitland Bottoms <bottoms@debian.org>  Tue, 26 Jan 2010 11:39:45 -0500

vtk (5.4.2-3) experimental; urgency=low

  [ Denis Barbier ]
  * Several VTK_USE_* features have lately been enabled.  Add
    development packages to Depends field of libvtk5-dev, those
    libraries are now listed in VTKLibraryDepends.cmake

  [ Dominique Belhachemi ]
  * Use virtual packages (libexpat-dev, libjpeg-dev, libpng-dev)
  * doxyfile.in updated (doxygen 1.6.2 supports SVG)
  * debian/rules: removed build-stamp target from docs-stamp target
  * debian/rules: removed install-stamp target from binary-indep target

 -- Dominique Belhachemi <domibel@cs.tu-berlin.de>  Tue, 05 Jan 2010 18:44:38 -0500

vtk (5.4.2-2) experimental; urgency=low


